#include "init.h"	// included by C-Wiz
#include "defines.h"
#include <htc.h>

char pwm, Ch1, Ch2, Ch3;
char clrMode=STARTMODE, clrSave, btnCount;
int  clrReady, clrDelay, btnReady;

void
main(void)
{
	init();												// Function call inserted by C-Wiz
	while (1){
		
		/*** Erzeugung des PWM-Signals ********************************************************/
				
		pwm++;											// Sgezahn erzeugen
		
		if(pwm >= Ch1) GP0 = 0;							// Sgezahn mit Farbwert vergleichen...
		else		   GP0 = 1;							// ...und PWM-Signal daraus erzeugen
		
		if(pwm >= Ch2) GP1 = 0;
		else		   GP1 = 1;
		
//		if(pwm >= Ch3) GP2 = 0;
//		else		   GP2 = 1;	
		
		/*** Farbsteuerung ********************************************************************/			
		
		if(clrReady) clrReady--;						// Farbwerte aktualisieren
		else											// ...
		{
			clrReady = CLRREADY;						// Zhler zurcksetzen
			
			switch (clrMode)							// welcher Modus?
			{
			 case 1:									//
				if(Ch1 > 0  ) Ch1--;					// Kanal 1 runterdimmen...
				if(Ch2 < 255) Ch2++;					// ...whrend Kanal 2 hochdimmt
				if(Ch1==0 && Ch2==255) 
				{
					clrDelay = CLRDELAY;
					clrMode++;
				}
				break;
				
			 case 2:
				if(clrDelay) clrDelay--;
				else
				{
					if(Ch1 == 255) clrMode--;
					else		   clrMode++;
				}
				break;
				
			 case 3:									// 
				if(Ch1 < 255) Ch1++;					// Kanal 2 runterdimmen...
				if(Ch2 > 0  ) Ch2 --;					// ...whrend Kanal 1 hochdimmt
				if(Ch1==255 && Ch2==0) 
				{
					clrDelay = CLRDELAY;
					clrMode--;
				}
				break;
				
			 case FIXEDCOLOR1:							// 
				Ch1 = 0;								// Kanal 1 aus...
				Ch2 = 255;								// ...und nur Kanal 2 an
				break;
				
			 case FIXEDCOLOR2:							// 
				Ch1 = 255;								// nur Kanal 1 an...
				Ch2 = 0;								// ...und Kanal 2 aus				
				break;
				
			 case STARTMODE:							// Startmodus
			 	Ch1 = 128;
			 	Ch2 = 128;
			 	clrMode = 1;
			 	break;
				
			 default:									// Alles aus!
			 	Ch1 = 0;
			 	Ch2 = 0;
			 	Ch3 = 0;
			}			
		}
		
		/*** Tasterabfrage ********************************************************************/
		
		if(btnReady) btnReady--;						// Zhler fr Tasterabfrage
		else											// Taster auslesen
		{
			if(GP3)										// Taster NICHT gedrckt...
			{
				if(btnCount)							// ...war der Taster gedrckt?
				{
					if(clrMode)							// wenn LEDs an sind...
					{
						if(clrMode < 3) clrSave = 255;
						else clrSave = clrMode;
						clrMode = 0;					// ...und LEDs aus schalten
					}
					else clrMode = clrSave;				// ...oder einschalten wenn sie aus sind
					btnCount = 0;						// Zhler fr Tasterdruck lschen
				}
				btnReady = BTNREADY;					// Zhler fr Tasterabfrage zurcksetzen
			}
		
			else										// Taster gedrckt...
			{	
				btnCount++;								// Zhler fr Tasterdruck inkrementieren
				if(btnCount > 18)						// Taster > 2Sek gedrckt:
				{
					GP0 = 0;
					GP1 = 0;
					GP2 = 0;
					
					btnReady = BTNRDYLNG;
					while(btnReady) btnReady--;
					
					if     (clrMode < FIXEDCOLOR1) clrMode = FIXEDCOLOR1;
					else if(clrMode < FIXEDCOLOR2) clrMode = FIXEDCOLOR2;
					else                 		   clrMode = STARTMODE;
					
					btnCount = 0;						// Zhler fr Tasterdruck lschen
					clrReady = 0;
					btnReady = BTNRDYLNG;				// Zhler fr Tasterabfrage zurcksetzen
				}
				else btnReady = BTNREADY;				// Zhler fr Tasterabfrage zurcksetzen
			}
		}		
		/*** Ende StateMachine ****************************************************************/	
	}
	/*** Ende Endlosschleife ******************************************************************/
}
/*** Ende main() ******************************************************************************/


